function RR_Test()
	ChatFrame1:AddMessage("Kilerpet's Raid Roll Addon - Loaded")
end

function RaidRoll_OnLoad()

 SLASH_RR1 = "/rr";
 SLASH_RR2 = "/raidroll";
 
 SlashCmdList["RR"] =  RR_Command;
 
 RR_Test()
 
 local f = CreateFrame("Frame")
 
  f:RegisterEvent("CHAT_MSG_SYSTEM")
  
  f:RegisterEvent("CHAT_MSG_PARTY")
  f:RegisterEvent("CHAT_MSG_RAID")
  f:RegisterEvent("CHAT_MSG_RAID_LEADER")
  f:RegisterEvent("CHAT_MSG_RAID_WARNING")
  f:RegisterEvent("CHAT_MSG_SAY")
  f:RegisterEvent("CHAT_MSG_YELL")
  
  
  f:SetScript("OnEvent", RaidRoll_Event)
  
  RR_Has_Rolled = false
  RR_Rolling_on_item = true
  
  rr_rollID = 0
  rr_CurrentRollID = 0
  rr_Roll = {}
  rr_PlayersRolled = {}
  rr_Item = {}
  rr_playername = {}
  RollerRoll = {}
  RollerName = {}
  RollerGroup = {}

  rr_Item[0] = "ID #0"
  
  RollerName[0] = {}
  
  RollerName[0][1] = ""
  
  RR_Timestamp = 0
  
  RR_Accept_All_Rolls = false	--Set true if all rolls are counted (False = only 1-100 rolls are counted)
  
  RR_Track_Unannounced_Rolls = false	--Set true if unannounced rolls are tracked
   
end


function RaidRoll_Event()
--ChatFrame1:AddMessage(arg1)

--ChatFrame1:AddMessage("An event has occured")

if event == "CHAT_MSG_PARTY" or event == "CHAT_MSG_RAID" or event == "CHAT_MSG_RAID_LEADER" or event == "CHAT_MSG_RAID_WARNING" or event == "CHAT_MSG_SAY" or event == "CHAT_MSG_YELL" then
	--ChatFrame1:AddMessage(arg1)	--Debugging, shows what messages are said
	
	arg1_s = string.lower(arg1)
	
--Find the start and end location of the item link
	xRR_Start_Loc,_ = string.find(arg1_s, "item:");
	_,xRR_End_Loc = string.find(arg1_s, "|h|r")
	
	if xRR_Start_Loc == nil then xRR_Start_Loc = 0 end
	if xRR_End_Loc == nil then xRR_End_Loc = 0 end
	
	
--Get the words before and after the item link
	RR_String_minus_ILink1 = strsub(arg1,0,xRR_Start_Loc-12)
	RR_String_minus_ILink2 = strsub(arg1,xRR_End_Loc,strlen(arg1))
	
--If they are nil set them to blank values
	if RR_String_minus_ILink1 == nil then RR_String_minus_ILink1 = "" end
	if RR_String_minus_ILink1 == nil then RR_String_minus_ILink1 = "" end

--Put them together
	RR_String_minus_ILink = RR_String_minus_ILink1 .. RR_String_minus_ILink2
	
--Debugging, Shows the item string without the item link
	--ChatFrame1:AddMessage(RR_String_minus_ILink)	
	
	if string.find(arg1_s, "|h|r") ~= nil and string.find(RR_String_minus_ILink, "roll") ~= nil and string.find(RR_String_minus_ILink, "raid roll") == nil then 
		--ChatFrame1:AddMessage("Rolling on an item detected")
		
	--Timestamp of when the rolling was announced
		RR_Timestamp = time()
		--ChatFrame1:AddMessage("Timestamp set to :" .. RR_Timestamp)	--Debugging, displays the timestamp
		
		
		
	--Cut the itemlink out of the string
		if xRR_Start_Loc ~= nil and xRR_End_Loc ~= nil then
			xRR_ItemLink = strsub(arg1,xRR_Start_Loc-12,xRR_End_Loc)
		end
	--For debugging, show the itemlink
		--ChatFrame1:AddMessage(xRR_ItemLink)
		
		if rr_Item[rr_rollID] ~= "ID #"..rr_rollID or RollerName[rr_rollID][1] ~= "" then
		
			rr_rollID = rr_rollID + 1	
			
			
			if rr_CurrentRollID+1 == rr_rollID then
				rr_CurrentRollID = rr_rollID
			end
		end
		
			rr_Item[rr_rollID] = xRR_ItemLink
			rr_RollSort(0,"",rr_rollID)

		

		
		--ChatFrame1:AddMessage("New item roll found, ID#" .. rr_rollID)
	end
	
	RR_Rolling_on_item = true
	
end

if RR_Rolling_on_item == true and event == "CHAT_MSG_SYSTEM" and string.find(arg1, "rolls")then 
	--ChatFrame1:AddMessage("Roll Detected")	--Debugging, fires when a roll is detected
	
	--ChatFrame1:AddMessage("Roll detected " .. time() - RR_Timestamp .. " seconds after announcement") 
	
	if time() < RR_Timestamp + 60 or RR_Track_Unannounced_Rolls == true then
		
	--This creates a new window for rolls made more than 60 seconds after the last roll if the option to track unannounced rolls is turned on
		if RR_Track_Unannounced_Rolls == true then
			if time() > RR_Timestamp + 60 then
				RR_NewRoll()
			end
		end
		
		RR_RollFrame:Show()
		
		if string.find(arg1, "%(1%-100%)") ~= nil or RR_Accept_All_Rolls == true then
			--ChatFrame1:AddMessage("Legitimate Roll")	--Debugging, tells you if the roll is a real roll or fake
			
			--Wait for the player to roll
			rr_endname,roll_loc = string.find(arg1, " rolls");
			
			roll_loc_end = string.find(arg1, " %(");
			
			
				--Find where in the roll the number is
			if roll_loc ~= nil then
				rr_player_roll = strsub(arg1,roll_loc+2,roll_loc_end-1)
				
				--if strsub(arg1,roll_loc+4,roll_loc+4) == "0" then 
				--	rr_player_roll = "100"
				--	ChatFrame1:AddMessage("Player rolled 100!")		--Debugging, only happens when 100 is rolled
				--end
				
				rr_player_name = strsub(arg1,1,rr_endname-1)
				
				--ChatFrame1:AddMessage(rr_player_name .. " Rolled " .. rr_player_roll)	--Debugging, shows what the player rolled
				
				if rr_Roll[rr_rollID] == nil then rr_Roll[rr_rollID] = {} end
				
				if rr_Roll[rr_rollID][rr_player_name] == nil then
					rr_Roll[rr_rollID][rr_player_name] = tonumber(rr_player_roll)
					if rr_PlayersRolled[rr_rollID] == nil then 
						rr_PlayersRolled[rr_rollID] = 1
					else
						rr_PlayersRolled[rr_rollID] = rr_PlayersRolled[rr_rollID] + 1
					end
					--ChatFrame1:AddMessage("Total players rolled: " .. rr_PlayersRolled[rr_rollID])	-- Debugging message, tells you how many ppl have rolled unique rolls
					
					if rr_playername[rr_rollID] == nil then	rr_playername[rr_rollID] = {} end
					
					rr_playername[rr_rollID][rr_PlayersRolled[rr_rollID]] = rr_player_name	
					
					rr_RollSort(rr_player_roll,rr_player_name,rr_rollID)
					
				else
					--ChatFrame1:AddMessage(rr_player_name .. " already rolled. Ignoring roll")	--Debugging message, tells you if ppl roll twice
				end
				
			end
			
		else
			--ChatFrame1:AddMessage("Fake Roll, Ignore")	--Debugging, shows when an unacceptable roll is done
		end
	end

end


if RR_Has_Rolled == true and event == "CHAT_MSG_SYSTEM" then
	
	--Wait for the player to roll
	null,roll_loc = string.find(arg1, UnitName("player") .. " rolls");

	--Find where in the roll the number is
	if roll_loc ~= nil then
		my_roll = strsub(arg1,roll_loc+2,roll_loc+3)
	end
	
	--Convert it from a string to a number
	my_roll = tonumber(my_roll)

	if GetRaidRosterInfo(my_roll) ~= nil and roll_loc ~= nil and RR_ItemLink == nil then
		SendChatMessage(">>> " .. RR_Name_Array[my_roll] .. " Wins! <<<", rr_AnnounceType1)
	end
	
	if GetRaidRosterInfo(my_roll) ~= nil and roll_loc ~= nil and RR_ItemLink ~= nil then
		SendChatMessage(">>> " .. RR_Name_Array[my_roll] .. " Wins " .. RR_ItemLink .. "! <<<", rr_AnnounceType1)
	end
	
	RR_Has_Rolled  = false
end


end




function rr_RollSort(PlayerRoll,PlayerName,rr_rollID)

local temp

	if RollerName[rr_rollID] == nil then RollerName[rr_rollID] = {} end
	for i=1,5 do
		if RollerName[rr_rollID][i] == nil then RollerName[rr_rollID][i] = "" end
	end
	RollerName[rr_rollID][6] = PlayerName
		


	if RollerRoll[rr_rollID] == nil then RollerRoll[rr_rollID] = {} end
	for i=1,5 do
		if RollerRoll[rr_rollID][i] == nil then RollerRoll[rr_rollID][i] = 0 end
	end
	RollerRoll[rr_rollID][6] = tonumber(PlayerRoll)

	--Debugging values 
	--[[
	RollerRoll[rr_rollID][1] = 2
	RollerRoll[rr_rollID][2] = 4
	RollerRoll[rr_rollID][3] = 5
	RollerRoll[rr_rollID][4] = 1
	RollerRoll[rr_rollID][5] = 9
	]]

	for i=1,6 do
		--ChatFrame1:AddMessage(i)	-- Debugging, shows the ''i'' value
		for j=1,5 do
			--ChatFrame1:AddMessage(j) 	-- Debugging, shows the ''j'' value
			if RollerRoll[rr_rollID][j+1] > RollerRoll[rr_rollID][j] then
				temp = RollerRoll[rr_rollID][j+1]
				RollerRoll[rr_rollID][j+1] = RollerRoll[rr_rollID][j]
				RollerRoll[rr_rollID][j] = temp
				
				temp = RollerName[rr_rollID][j+1]
				RollerName[rr_rollID][j+1] = RollerName[rr_rollID][j]
				RollerName[rr_rollID][j] = temp
			end
		end
	end
	
--Debugging, lists all the raid rolls
	--[[ChatFrame1:AddMessage("Listing Results")
	for i=1,6 do
		ChatFrame1:AddMessage(RollerName[rr_rollID][i])
		ChatFrame1:AddMessage(RollerRoll[rr_rollID][i])
	end
	]]
	
	if rr_CurrentRollID == rr_rollID then
			RR_Display(rr_rollID)
	end
	
	
	
end

function RR_Update_Name_Frame(RR_DisplayID)

l_RR_DisplayID = RR_DisplayID

	if time() < RR_Timestamp + 60 and rr_rollID == rr_CurrentRollID then
		getglobal("RR_Itemname"):SetText("(" .. 60 - time() + RR_Timestamp .. ") " .. rr_Item[l_RR_DisplayID])
	else
		getglobal("RR_Itemname"):SetText(rr_Item[l_RR_DisplayID])
	end
	
	if not _RR then 
		UIParent:HookScript("OnUpdate",function() if _RR>0 and GetTime()>=_RR then _RR=0 RR_Update_Name_Frame(l_RR_DisplayID); end end)
	end 
	_RR=GetTime()
	
end

function RR_Display(RR_DisplayID)

l_RR_DisplayID = RR_DisplayID

	if RollerGroup[l_RR_DisplayID] == nil then RollerGroup[l_RR_DisplayID] = {} end

---If the current roll is the latest rol it shows a 60 second countdown
	if time() < RR_Timestamp + 60 and rr_rollID == rr_CurrentRollID then
		getglobal("RR_Itemname"):SetText("(" .. 60 - time() + RR_Timestamp .. ") " .. rr_Item[l_RR_DisplayID])
		RR_Update_Name_Frame(l_RR_DisplayID)
	else
		getglobal("RR_Itemname"):SetText(rr_Item[l_RR_DisplayID])
	end
	
	
	for i=1,5 do
		getglobal("RR_Roller"..i):SetText(RollerName[RR_DisplayID][i])
		getglobal("RR_Rolled"..i):SetText(RollerRoll[RR_DisplayID][i])
	end
	
	for j = 1,5 do
		for i = 1,40 do
			local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(i);
			
			if name == RollerName[RR_DisplayID][j] then
				RollerGroup[RR_DisplayID][j] = subgroup
			end
		end
		
		if RollerGroup[RR_DisplayID][j] == nil then RollerGroup[RR_DisplayID][j] = "" end
		getglobal("RR_Group"..j):SetText(RollerGroup[RR_DisplayID][j])
	end

	RR_RollFrame:Show()
	
	if rr_rollID ~= 0 then
		if rr_CurrentRollID < rr_rollID then
			RR_Next:Enable()
		else
			RR_Next:Disable()
		end
		
		if rr_CurrentRollID > 0 then
			RR_Last:Enable()
		else
			RR_Last:Disable()
		end
	else
		RR_Last:Disable()
		RR_Next:Disable()
	end
	
end


function RR_Command(cmd)
--Stuff that happens when you press /mm <command>

RR_ItemLink = nil --clearing the variable

cmd_n = tonumber(cmd)

--Do a standard Raid roll
	if cmd_n ~= nil or cmd == "" then 
		if GetNumRaidMembers() ~= 0 then
			if cmd == "" then
				RR_DoARaidRoll(GetNumRaidMembers())
			end
			
			if type(cmd_n) == "number" then
				if cmd_n > GetNumRaidMembers() then
					cmd_n = GetNumRaidMembers();
				end
				
				--ChatFrame1:AddMessage(cmd_n)
				RR_DoARaidRoll(cmd_n)
			end
			
			--ChatFrame1:AddMessage(type(cmd_n))
		else
			ChatFrame1:AddMessage("You are not in a raid group")
		end
	end

	
cmd_s = string.lower(cmd)

	if cmd_s == "show" then
		RR_RollFrame:Show()
	end
	
	if cmd_s == "test" then
		 RR_Test()
	end	
	
	--[[if cmd_s == "re" or cmd_s == "reroll" then
		if RR_num ~= nil then
			RR_Roll()
		else
			RR_DoARaidRoll(GetNumRaidMembers())
		end
	end	]]--
	
--Find the start and end location of the item link
	RR_Start_Loc,_ = string.find(cmd, "item:");
	_,RR_End_Loc = string.find(cmd, "|h|r")
	
--Cut the itemlink out of the string
	if RR_Start_Loc ~= nil and RR_End_Loc ~= nil then
		RR_ItemLink = strsub(cmd,RR_Start_Loc-12,RR_End_Loc)
	end
--For debugging, show the itemlink
	--ChatFrame1:AddMessage(RR_ItemLink)

--Cut up the command to see if it was a reroll or not
	RR_Reroll = strsub(cmd_s,1,2)
	RR_Reroll_Long = strsub(cmd_s,1,6)
	
--for debugging, show the results of the split up string
	--ChatFrame1:AddMessage(RR_Reroll)
	--ChatFrame1:AddMessage(RR_Reroll_Long)
	

	if RR_Reroll == "re" or RR_Reroll_Long == "reroll" then
		if RR_num ~= nil then
			if RR_ItemLink ~= nil then
				SendChatMessage("<<Raid Rolling for: ".. RR_ItemLink .. " >>" , rr_AnnounceType2)
			end
			
			RR_Roll()
		else
			RR_DoARaidRoll(GetNumRaidMembers())
		end
	end
	
	if strsub(cmd,1,1) == "|" then
		RR_DoARaidRoll(GetNumRaidMembers())
	end
	
	if cmd_s == "all" then
		if RR_Accept_All_Rolls == true then
			RR_Accept_All_Rolls =  false
			ChatFrame1:AddMessage("Raid Roll: Only 1-100 rolls accepted")
		else
			RR_Accept_All_Rolls =  true
			ChatFrame1:AddMessage("Raid Roll: All rolls accepted")
		end
		
	end
	
	
	if cmd_s == "unan" or cmd_s == "unannounced" then
		if RR_Track_Unannounced_Rolls == true then
			RR_Track_Unannounced_Rolls =  false
			ChatFrame1:AddMessage("Raid Roll: Auto-Tracking Rolls Disabled")
		else
			RR_Track_Unannounced_Rolls =  true
			ChatFrame1:AddMessage("Raid Roll: Auto-Tracking Rolls Enabled")
		end
	end	
	
end

function RR_DoARaidRoll(num)

	RR_num = num
	
	RR_Name_Array = {}
	
	if UnitInRaid("player") then 
		rr_AnnounceType1 = "RAID"
		if IsRaidLeader() ~= nil or IsRaidOfficer() ~= nil then
			rr_AnnounceType2 = "RAID_WARNING"
		else
			rr_AnnounceType2 = "RAID"
		end
	else
		rr_AnnounceType1 = "PARTY"
		rr_AnnounceType2 = "PARTY"
	end		
	
	if RR_ItemLink == nil then
		SendChatMessage("<<Raid Rolling>> (ID - Name)" , rr_AnnounceType1)
	end
	
	if RR_ItemLink ~= nil then
		SendChatMessage("<<Raid Rolling for: " .. RR_ItemLink .. " >> (ID - Name)" , rr_AnnounceType2)
	end
	
	for i=1,num do
		RR_Name_Array[i] = GetRaidRosterInfo(i)
		--SendChatMessage(RR_Name_Array[i], "PARTY")	--Debugging, shows all the members of the raid in party chat
	end
		
	if num < 21 then 
		num = num + 1
		for i=1,num/2 do
			i_mod = 2 * i
			--ChatFrame1:AddMessage(i_mod .. num)
			if GetRaidRosterInfo(i_mod) ~= nil and i_mod <= num-1 then 
				SendChatMessage("#".. i_mod-1 .." - " .. GetRaidRosterInfo(i_mod-1) .. "" .. "    #" .. i_mod .." - " .. GetRaidRosterInfo(i_mod), rr_AnnounceType1)
			else
				SendChatMessage("#".. i_mod-1 .." - " .. GetRaidRosterInfo(i_mod-1), rr_AnnounceType1)
			end
			--ChatFrame1:AddMessage("#".. i .." - " .. GetRaidRosterInfo(i))
			--ChatFrame1:AddMessage(num)				
		end
	else
		num = num + 2
		for i=1,num/3 do
			i_mod = 3 * i
			--ChatFrame1:AddMessage(i_mod .. num)
			if GetRaidRosterInfo(i_mod) ~= nil and i_mod <= num-2 then 
				SendChatMessage("#".. i_mod-2 .." - " .. GetRaidRosterInfo(i_mod-2) .. "    #" .. i_mod-1 .." - " .. GetRaidRosterInfo(i_mod-1) .. "    #" .. i_mod .." - " .. GetRaidRosterInfo(i_mod), rr_AnnounceType1)
			elseif GetRaidRosterInfo(i_mod-1) ~= nil and  i_mod <= num-1 then
				SendChatMessage("#".. i_mod-2 .." - " .. GetRaidRosterInfo(i_mod-2) .. "" .. "    #" .. i_mod-1 .." - " .. GetRaidRosterInfo(i_mod-1), rr_AnnounceType1)
			else
				SendChatMessage("#".. i_mod-2 .." - " .. GetRaidRosterInfo(i_mod-2), rr_AnnounceType1)
			end
			--ChatFrame1:AddMessage("#".. i .." - " .. GetRaidRosterInfo(i))
			--ChatFrame1:AddMessage(num)				
		end
	end
	
	if not _Y then 
		UIParent:HookScript("OnUpdate",function() if _Y>0 and GetTime()>=_Y then _Y=0 RR_Roll(); end end)
	end 
	_Y=GetTime()+2
	
end

function RR_Roll()

RandomRoll(1,RR_num);

RR_Has_Rolled = true

end


function RR_CloseWindow()
	RR_RollFrame:Hide()
end

function RR_PrevRoll()
	if rr_CurrentRollID > 0 then
		rr_CurrentRollID = rr_CurrentRollID - 1
		RR_Display(rr_CurrentRollID)
	end
	
	if rr_CurrentRollID == 0 then 
		RR_Last:Disable()
		RR_Next:Enable()
	else
		RR_Last:Enable()
		RR_Next:Enable()
	end
end

function RR_NewRoll()
	
	RR_Timestamp = time()
	--ChatFrame1:AddMessage("Timestamp set to :" .. RR_Timestamp)	--Debugging, displays the timestamp

	if RollerName[rr_rollID][1] ~= "" or rr_Item[rr_rollID] ~= "ID #"..rr_rollID then
		rr_rollID = rr_rollID + 1		
		
		rr_Item[rr_rollID] = "ID #"..rr_rollID
		
		
		if rr_CurrentRollID+1 == rr_rollID then
			rr_CurrentRollID = rr_rollID
			RR_Last:Enable()
		end
		
		rr_RollSort(0,"",rr_rollID)
	end
end

function RR_NextRoll()
	if rr_CurrentRollID < rr_rollID then
		rr_CurrentRollID = rr_CurrentRollID + 1
		RR_Display(rr_CurrentRollID)
	end
	
	if rr_CurrentRollID == rr_rollID then 
		RR_Next:Disable()
		RR_Last:Enable()
	else
		RR_Next:Enable()
		RR_Last:Enable()
	end	
end
